from es import setindexprop, getindexprop, getplayerprop, getindexfromhandle, doblock
from weaponlib import getWeaponNameList
from random import randint
from gamethread import delayed
from superdice.libs.diceConfigs import configFile
from superdice.superdice import registerRoll, unregisterRoll, players

def es_map_start(ev):
    cfgData.execute()

def unload():
    unregisterRoll(diceRoll)
    doblock('corelib/noisy_off')

def player_spawn(ev):
    players[ev['userid']]['wpnjam'] = False

def weapon_fire(ev):
    if not randint(0, 100) <= int(chance):
        return

    userid = ev['userid']
    weapon = 'weapon_' + ev['weapon']
    if not players[userid]['wpnjam'] or not weapon in primarys and not weapon in secondarys:
        return

    weaponIndex = getindexfromhandle(getplayerprop(userid, 'CBaseCombatCharacter.m_hActiveWeapon'))
    prevAmmo = getindexprop(weaponIndex, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1')
    if prevAmmo < 1:
        return
    
    setindexprop(weaponIndex, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1', 0)
    delayed(0.2, setindexprop, (weaponIndex, 'CBaseCombatWeapon.LocalWeaponData.m_iClip1', prevAmmo))

def diceRoll(userid, player, eplayer):
    players[userid]['wpnjam'] = True

cfgData = configFile('dice_weaponjam')
chance = cfgData.cvar('superdice_cfg_weaponjam_chance', 10, 'What is the chance for weapon jamming to happen?')
cfgData.write()
cfgData.execute()

registerRoll(diceRoll, 'Weapon Jamming', 'You have the chance for your weapons to jam.')

primarys = getWeaponNameList('#primary')

secondarys = getWeaponNameList('#secondary')

doblock('corelib/noisy_on')
